package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckLeaveFactoryResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckLeaveFactoryResultMapper extends IBaseMapper<TmstruckLeaveFactoryResult, BigDecimal> {
    //查询最大ID
    @Select("select seq_tmstruck_leavefactory.nextval from dual")
    BigDecimal selectMaxId();

    //查询所有的出厂实绩、
    List<Map<String, Object>> getLeaveFactoryResult(Map<String, Object> map);

    //查询运输路线是否为出厂
    Integer selectTransportRoute(String orderNumber);

    //查询车牌号与门岗
    Map<String,Object> selectCnAndGnByOrderNumber(String orderNumber);

    //根据订单号获取实绩id
    Map<String, Object> selectResultId(String orderNumber);

    //销售物流查询所有的出厂实绩
    List<Map<String,Object>> selectAllLeaveFacatoryForSale(Map<String,Object> map);
}