package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckUnloadResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckUnloadResultMapper extends IBaseMapper<TmstruckUnloadResult, BigDecimal> {
    //查询卸货实绩
    List<Map<String, Object>> getUnloadResult(Map<String, Object> map);

    //查询最大ID值
    @Select("select seq_tmstruck_unload_result.nextval from dual")
    BigDecimal selectMaxId();

    // 通过总实绩id查询卸货实绩id
    BigDecimal getResultIdByTotalId(BigDecimal totalId);

    //通过运输订单号查询 实绩Id 和总实绩Id
    Map<String, Object> selectTotalIdByOrderNo(String orderNumber);

    //通过卸货地点查询仓库Id
    BigDecimal getWarehouseIdByWName(String warehouseName);

    //根据运输订单号查找装车实绩
    Map<String,Object> selectUnloadResultIdByOrderNumber(String orderNumber);
}