package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckWeightResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckWeightResultMapper extends IBaseMapper<TmstruckWeightResult, Short> {
    //查询最大主键Id
    @Select("select seq_tmstruck_weight_result.nextval from dual")
    BigDecimal selectMaxId();

    //通过订单号查询计重实绩数据
    Map<String, Object> selectTotalIdByOrderNo(String orderNumber);

    //通过汽车衡编号查询汽车衡ID
    Integer selectTruckCalculateId(String truckCalculateNumber);

    //查询所有计毛实绩
    List<Map<String, Object>> getAllJiMaoResult(Map<String, Object> map);

    //查询所有计皮实绩
    List<Map<String, Object>> getAllJiPiResult(Map<String, Object> map);

    //查询订单下所有的物资件数和物资理重
    List<Map<String, Object>> getMaterialMes(Integer orderId);

    //通过物资ID查询应该在哪个汽车衡计量
    List<Integer> getCalculateIdByMaterial(BigDecimal material);

}