package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstruckTotalResultMapper;
import com.steerinfo.dil.model.TmstruckTotalResult;
import com.steerinfo.dil.service.ITmstruckTotalResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/27 10:18
 */

@Service(value = "tmstruckTotalResultService")
public class TmstruckTotalResultServiceImpl implements ITmstruckTotalResultService {

    @Autowired
    private TmstruckTotalResultMapper tmstruckTotalResultMapper;

    /**
     * 新增实绩总表
     * 运输订单ID
     * @param orderId
     * @return
     */
    public int addTotalResult(BigDecimal orderId){
        TmstruckTotalResult tmstruckTotalResult = new TmstruckTotalResult();
        tmstruckTotalResult.setResultTotalId(tmstruckTotalResultMapper.selectMaxId());
        tmstruckTotalResult.setOrderId(orderId);
        tmstruckTotalResult.setInsertTime(new Date());
        tmstruckTotalResult.setInsertUsername("admin");
        return tmstruckTotalResultMapper.insertSelective(tmstruckTotalResult);
    }
    /**
     * 展示计数实绩列表
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> selectCountList(Map<String, Object> map) {
        return tmstruckTotalResultMapper.selectCountList(map);
    }

}
