package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstruckReceiptResultMapper;
import com.steerinfo.dil.mapper.TmstruckWeightResultMapper;
import com.steerinfo.dil.model.TmstruckReceiptResult;
import com.steerinfo.dil.model.TmstruckWeightResult;
import com.steerinfo.dil.service.ITmstruckWeightResultService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmstruckWeightResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-09 02:21
 * 类描述
 * 修订历史：
 * 日期：2021-09-09
 * 作者：generator
 * 参考：
 * 描述：TmstruckWeightResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstruckWeightResultService")
public class TmstruckWeightResultServiceImpl implements ITmstruckWeightResultService {

    @Autowired
    private TmstruckWeightResultMapper tmstruckWeightResultMapper;

    @Autowired
    private TmstruckReceiptResultMapper tmstruckReceiptResultMapper;

    @Autowired
    private UtilsServiceImpl utilsService;

    /**
     * 查询所有计毛实绩
     * @param map
     * @return
     */

    @Override
    public List<Map<String, Object>> getAllJiMaoResult(Map<String, Object> map) {
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            case 1:

                break;
            case 2:

                break;
            case 3:

                break;
            case 4:

                break;
            case 5:

                break;
            case 6:

                break;
            case 7:

                break;
            case 8:
                return tmstruckWeightResultMapper.getAllJiMaoResult(map);
            case 9:
                break;
            case 10:

                break;
            case 11:

        }
        return null;
    }

    /**
     * 查询所有计皮实绩
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllJiPiResult(Map<String, Object> map) {
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            case 1:

                break;
            case 2:

                break;
            case 3:

                break;
            case 4:

                break;
            case 5:

                break;
            case 6:

                break;
            case 7:

                break;
            case 8:
                return tmstruckWeightResultMapper.getAllJiPiResult(map);
            case 9:
                break;
            case 10:

                break;
            case 11:

        }
        return null;
    }

    /**
     * 派单时新增计重实绩
     * 总实绩ID、计皮点、计毛点
     * @return
     */
    @Override
    public int addWeightResult(Map<String, Object> map) {
        TmstruckWeightResult tmstruckWeightResult = new TmstruckWeightResult();
        //生成最大主键ID
        tmstruckWeightResult.setWeightTaskResultId(tmstruckWeightResultMapper.selectMaxId());
        tmstruckWeightResult.setResultTotalId(DataChange.dataToBigDecimal(map.get("resultTotalId")));
        // 添加计皮计毛作业点ID
        tmstruckWeightResult.setResultGrossPlaceId(DataChange.dataToBigDecimal(map.get("truckCalculateIdMao")));
        tmstruckWeightResult.setResultTarePlaceId(DataChange.dataToBigDecimal(map.get("truckCalculateIdPi")));
        return tmstruckWeightResultMapper.insertSelective(tmstruckWeightResult);
    }

    /**
     * 通过物资ID获取对应汽车衡 如果有多个汽车衡中随机选择
     * @param materialId
     * @return
     */
    @Override
    public int getCalculateIdByMaterial(BigDecimal materialId) {
        List<Integer> calculateIdList = tmstruckWeightResultMapper.getCalculateIdByMaterial(materialId);
        return calculateIdList.get((int)(Math.random()*calculateIdList.size()));
    }

    /**
     * 更新计毛实绩 采集需要的数据
     *  运输订单号
     *  汽车衡编号
     *  //物资名称
     *  毛重
     *  毛重时间
     *  磅单号
     * @return
     */
    @Override
    @Transactional
    public int addJiMaoResult(Map<String, Object> map) {
        TmstruckWeightResult tmstruckWeightResult = new TmstruckWeightResult();
        //通过传来的运输订单号查询计重实绩
        map.putAll(tmstruckWeightResultMapper.selectTotalIdByOrderNo((String) map.get("orderNumber")));
        BigDecimal weightTaskResultId = DataChange.dataToBigDecimal(map.get("weightTaskResultId"));
        tmstruckWeightResult.setWeightTaskResultId(weightTaskResultId);
        //添加毛重
        DecimalFormat df =  new DecimalFormat("0.00");
        String resultGrossWeight = df.format((double) map.get("resultGrossWeight"));
        tmstruckWeightResult.setResultGrossWeight(new BigDecimal(resultGrossWeight));
        Integer lineSequence = null; //路段顺序号
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            //如果订单类型为销售订单 则执行销售订单计皮规则 resultTareWeight
            case 1:
                //计算净重  从map中获取皮重 tareWeight
                double netWeight = ((BigDecimal) map.get("resultGrossWeight")).doubleValue() - ((Double) map.get("tareWeight"));
                String resultNetWeight = df.format(netWeight);
                tmstruckWeightResult.setResultNetWeight(new BigDecimal(resultNetWeight));
                addUpdateRegularField(tmstruckWeightResult); //插入第二次计重时间
                lineSequence = 5; //设置路段顺序号为5：出厂
                break;
            //采购订单记录计毛为第一次计重
            case 3:
                addInsertRegularField(tmstruckWeightResult); //插入第一次计重时间
                lineSequence = 5; //设置路段顺序号为5：出厂
        }

        //通过汽车衡编号查询汽车衡ID
        Integer calculateId = tmstruckWeightResultMapper.selectTruckCalculateId((String) map.get("truckCalculateNumber"));
        //添加计毛汽车衡
        if(calculateId != null){
            tmstruckWeightResult.setResultGrossPlaceId(new BigDecimal(calculateId));
        }
        //添加磅单号
        tmstruckWeightResult.setResultPoundNo((String) map.get("resultPoundNo"));
        //添加毛重时间
        long resultGrossWeightTime = (long) map.get("resultGrossWeightTime");
        tmstruckWeightResult.setResultGrossWeightTime(new Date(resultGrossWeightTime));

        int i = tmstruckWeightResultMapper.updateByPrimaryKeySelective(tmstruckWeightResult);
        //更新订单路段顺序号
        int i2 = utilsService.updateOrderLineSequence(map, lineSequence);
        return i +i2;
    }



    /**
     * 更新计皮实绩  需要采集的数据
     * 运输订单号 orderNumber
     * 汽车衡编号 truckCalculateNumber
     * 皮重 resultTareWeight
     * 皮重时间 resultTareWeightTime
     * 净重
     * @param map
     * @return
     */
    @Override
    @Transactional
    public int addJiPiResult(Map<String, Object> map) {
        TmstruckWeightResult tmstruckWeightResult = new TmstruckWeightResult();
        //通过传来的运输订单号查询计重实绩
        map.putAll(tmstruckWeightResultMapper.selectTotalIdByOrderNo((String) map.get("orderNumber")));
        BigDecimal resultId = (BigDecimal) map.get("weightTaskResultId");
        tmstruckWeightResult.setWeightTaskResultId(resultId);
        //添加皮重
        DecimalFormat df =  new DecimalFormat("0.00");
        String resultTareWeight = df.format((double) map.get("resultTareWeight"));
        tmstruckWeightResult.setResultTareWeight(new BigDecimal(resultTareWeight));
        //添加皮重时间
        long resultTareWeightTime = (long) map.get("resultTareWeightTime");
        tmstruckWeightResult.setResultTareWeightTime(new Date(resultTareWeightTime));

        int i1 = 0;
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            //如果订单类型为采购订单 则执行采购订单计皮规则
            case 3:
                //计算净重  先从map中获取毛重 grossWeight
                double netWeight = ((BigDecimal) map.get("grossWeight")).doubleValue() - ((Double) map.get("resultTareWeight"));
                String resultNetWeight = df.format(netWeight);
                tmstruckWeightResult.setResultNetWeight(new BigDecimal(resultNetWeight));
                addUpdateRegularField(tmstruckWeightResult); // 添加更新常规字段 就是第二次计重时间
                //计皮作业完成后自动完成签收
                TmstruckReceiptResult tmstruckReceiptResult = new TmstruckReceiptResult();
                tmstruckReceiptResult.setResultTotalId(DataChange.dataToBigDecimal(map.get("resultTotalId")));
                tmstruckReceiptResult.setStatus(new BigDecimal(1));
                tmstruckReceiptResult.setInsertUsername("admin");
                tmstruckReceiptResult.setInsertTime(new Date());
                i1 = tmstruckReceiptResultMapper.updateByTotalResultId(tmstruckReceiptResult);
                break;
            //销售订单计皮为第一次计重
            case 1:
                addInsertRegularField(tmstruckWeightResult);// 添加插入常规字段 就是第一次计重时间
        }

        //通过汽车衡编号查询汽车衡ID
        Integer calculateId = tmstruckWeightResultMapper.selectTruckCalculateId((String) map.get("truckCalculateNumber"));
        //添加计皮汽车衡
        if(calculateId != null){
            tmstruckWeightResult.setResultTarePlaceId(new BigDecimal(calculateId));
        }
        int i = tmstruckWeightResultMapper.updateByPrimaryKeySelective(tmstruckWeightResult);
        //更新订单路段顺序号
        int i2 = utilsService.updateOrderLineSequence(map, 4);
        return i + i1 + i2;
    }

    /**
     * 添加首次计重时的常规字段
     * @param tmstruckWeightResult
     */
    public void addInsertRegularField(TmstruckWeightResult tmstruckWeightResult){
        tmstruckWeightResult.setInsertTime(new Date());
        tmstruckWeightResult.setInsertUsername("admin");
        tmstruckWeightResult.setInsertUpdateRemark("无");
    }

    /**
     * 添加第二次计重时的常规字段
     * @param tmstruckWeightResult
     */
    public void addUpdateRegularField(TmstruckWeightResult tmstruckWeightResult){
        tmstruckWeightResult.setUpdateTime(new Date());
        tmstruckWeightResult.setUpdateUsername("admin");
    }
}
